/* Cyclops
 * FER - SPVP
 * Fakultet elektrotehnike i racunarstva (http://www.fer.hr/)
 * Unska 3, 10000 Zagreb, Hrvatska
 * (c) 2001 FER, Zagreb.
 */


package hr.fer.zesoi.cyclops;

import java.util.*;


/**
 * Table element for RIPTable.
 * @author Tomislav Petkovi 
 */
class RIPTableElement
{

    /** Next node for route to destination_node. */
    Node next_node;

    /** Destination node (or network). */
    Node destination_node;

    /** Route cost. 16 is infinity. */
    float cost;

    /** Timer for route expiration. When this timer hits
     * zero, the route is no longer valid, but the table
     * entry is retained.
     */
    int route_timeout;

    /** Garbage collector timeout. When the route becomes
     * invalid, table entry is retained for defined amounot
     * of time (because all neighbourind nodes must be
     * informed of topology change).
     */
    int garbage_timeout;

    /** Route change flag. */
    boolean route_change_flag;

    /**
     * Default constructor.
     * @param destination_node Reference of destination node or network.
     * @param next_node Reference of next node along a path to destination.
     * @param cost Cost of a route.
     */
    public RIPTableElement (Node destination_node, Node next_node, float cost)
    {
	this.destination_node = destination_node;
	this.next_node = next_node;
	this.cost = cost;
	route_timeout = 5;
	garbage_timeout = 5;
	route_change_flag = true;
    }
    /* RIPTableElement */

}
/* RIPTableElement */
